=== debian/changelog ===
libpdb-redo (3.3.0-2) unstable; urgency=medium

  * Fix upload

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Sun, 07 Sep 2025 10:07:31 +0200

libpdb-redo (3.3.0-1) unstable; urgency=medium

  * New upstream version
  * Closes: #1101924

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 02 Apr 2025 13:07:03 +0200

libpdb-redo (3.2.1-2) unstable; urgency=medium

  * update package name due to changed SONAME

 -- Maarten L. Hekkelman <maarten@hekkelman.com>  Wed, 29 Jan 2025 11:58:38 +0100
