=== debian/tests/control ===
Tests: run-unit-test
Depends: @, @builddeps@, mrc
Restrictions: allow-stderr
