=== debian/watch ===
version=4

#  - when using releases:
# opts="filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
#   https://github.com/PDB-REDO/libpdb-redo/releases/latest .*/archive/v@ANY_VERSION@\.tar\.gz
#  - when using tags
opts="filenamemangle=s%(?:.*?)?v(\d[\d.]*)\.tar\.gz%@PACKAGE@-$1.tar.gz%" \
  https://github.com/PDB-REDO/libpdb-redo/tags .*/v@ANY_VERSION@\.tar\.gz
