## libpdb-redo 3.3.1

=== CMakeLists.txt ===
--- 
+++ 
@@ -25,7 +25,7 @@
 cmake_minimum_required(VERSION 3.16)
 
 # set the project name
-project(libpdb-redo VERSION 3.3.0 LANGUAGES CXX C)
+project(libpdb-redo VERSION 3.3.1 LANGUAGES CXX C)
 
 list(APPEND CMAKE_MODULE_PATH "${PROJECT_SOURCE_DIR}/cmake")
 
@@ -35,7 +35,7 @@
 include(CheckLibraryExists)
 include(CMakePackageConfigHelpers)
 include(CheckCXXSourceCompiles)
-include(FindOrFetch)
+include(CPM)
 include(GenerateExportHeader)
 include(CTest)
 
@@ -63,7 +63,7 @@
 
 if(BUILD_FOR_CCP4)
 	if("$ENV{CCP4}" STREQUAL "" OR NOT EXISTS $ENV{CCP4})
-		message(FATAL_ERROR "A CCP4 built was requested but CCP4 was not sourced")
+		message(FATAL_ERROR "pdb-redo: A CCP4 built was requested but CCP4 was not sourced")
 	else()
 		list(APPEND CMAKE_MODULE_PATH "$ENV{CCP4}")
 		list(APPEND CMAKE_PREFIX_PATH "$ENV{CCP4}")
@@ -110,9 +110,11 @@
 find_package(CCP4 REQUIRED ccp4c clipper-core clipper-ccp4 clipper-contrib)
 find_package(GSL REQUIRED)
 
-if(NOT (cifpp_FOUND OR TARGET cifpp))
-	find_or_fetch_package(cifpp VERSION 7.0.9 GIT_REPOSITORY https://github.com/PDB-REDO/libcifpp.git GIT_TAG v7.0.9 VARIABLES "CIFPP_SHARE_DIR")
-endif()
+CPMFindPackage(
+	NAME cifpp
+	GIT_REPOSITORY https://github.com/PDB-REDO/libcifpp.git
+	VERSION 9.0.5
+)
 
 # Create a revision file, containing the current git version info
 include(VersionString)
@@ -121,6 +123,7 @@
 # Sources
 list(APPEND project_sources
 	${PROJECT_SOURCE_DIR}/src/AtomShape.cpp
+	${PROJECT_SOURCE_DIR}/src/BlobFinder.cpp
 	${PROJECT_SOURCE_DIR}/src/BondMap.cpp
 	${PROJECT_SOURCE_DIR}/src/ClipperWrapper.cpp
 	${PROJECT_SOURCE_DIR}/src/Compound.cpp
@@ -136,6 +139,7 @@
 
 list(APPEND project_headers
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/AtomShape.hpp
+	${PROJECT_SOURCE_DIR}/include/pdb-redo/BlobFinder.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/BondMap.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/ClipperWrapper.hpp
 	${PROJECT_SOURCE_DIR}/include/pdb-redo/Compound.hpp
@@ -153,11 +157,13 @@
 	list(APPEND project_sources
 		${PROJECT_SOURCE_DIR}/src/Minimizer.cpp
 		${PROJECT_SOURCE_DIR}/src/Restraints.cpp
+		${PROJECT_SOURCE_DIR}/src/ShapeFitter.cpp
 	)
 
 	list(APPEND project_headers
 		${PROJECT_SOURCE_DIR}/include/pdb-redo/Minimizer.hpp
 		${PROJECT_SOURCE_DIR}/include/pdb-redo/Restraints.hpp
+		${PROJECT_SOURCE_DIR}/include/pdb-redo/ShapeFitter.hpp
 	)
 endif()
