=== debian/control ===
--- 
+++ 
@@ -5,15 +5,13 @@
 Uploaders: Maarten L. Hekkelman <maarten@hekkelman.com>
 Build-Depends:
  debhelper-compat (= 13),
- libcifpp-dev (>= 7),
+ libcifpp-dev (>= 9.0.5),
  cmake,
  libcatch2-dev,
  pkgconf,
  libgsl-dev,
- libboost-regex-dev,
  libeigen3-dev,
  libclipper-dev,
- zlib1g-dev,
  libccp4-dev (>= 6.5.1-5)
 Standards-Version: 4.7.0
 Vcs-Browser: https://salsa.debian.org/med-team/libpdb-redo
